#include "StdAfx.h"
#include ".\smepackage.h"
#include "savePackage.h"

using namespace PackageManager;


//////////////////////////////////////////////////////////////////////////
// macro


//////////////////////////////////////////////////////////////////////////
// static function

// Return whether modulus of elem1 is greater than modulus of elem2
static bool mod_more ( CStage elem1, CStage elem2 )
{
	return elem1.m_nStageUID < elem2.m_nStageUID;
};


//////////////////////////////////////////////////////////////////////////
// constructor
CSMEPackage::CSMEPackage(void)
{
	// Ʈ Ŭ
	m_listOfStage.clear();
}

CSMEPackage::~CSMEPackage(void)
{
	// Ʈ Ŭ
	m_listOfStage.clear();
}


//  ó
bool CSMEPackage::LoadFromDisk( CStdioFile* pFile )
{
	bool bResult = false;

	if( pFile )
	{
		CString strLine;

		// Save Path Name
		m_strPathName = pFile->GetFilePath();

		//  
		CString strTempFiles = m_strPathName + L".tmp";

		// Ͽ ;  ϴ ͵  
		CStdioFile file( strTempFiles, CStdioFile::modeCreate | CStdioFile::modeReadWrite | CStdioFile::modeNoTruncate );
		while( pFile->ReadString( strLine ) )
		{
			if( strLine.Left(1) == L";" )
				continue;

			strLine.Trim(L"\n");
			strLine.TrimLeft( L";" );

			if( strLine.GetLength() )
			{
				strLine += L"\n";

				file.WriteString( strLine );
			}
		}

		// ġ ̵
		file.SeekToBegin();
		

		//  б
		if( file.ReadString( strLine ) )
		{
			//   
			int nStageCount = ::_ttoi( strLine );

			for( int n = 0 ; n < nStageCount ; n++ )
			{
				CStage stage;
				stage.LoadFromDisk( &file );

				m_listOfStage.push_back( stage );

				if( n == 0 )
					m_currentStage = stage;
			}
		}

		if( m_listOfStage.size() > 0 )
			m_listOfStage.sort( mod_more );


		file.Close();

		// temp  
		DeleteFile( strTempFiles );
	}
	

	return bResult;
}

//  ó
bool CSMEPackage::DumpToDisk( CStdioFile* pFile )
{
	if( pFile == NULL )
	{
		CStdioFile file( m_strPathName, CStdioFile::modeWrite );

		if( file.m_hFile )
		{
			//  Ϸ 
			CString strStageCount;
			strStageCount.Format( L"%d ; stage count\n", m_listOfStage.size() );
			file.WriteString( strStageCount );

			// Ϸ 
			// m_listOfStage  Ѵ.
			list<CStage> ::iterator l_stage_iter;
			for( l_stage_iter = m_listOfStage.begin() ; l_stage_iter != m_listOfStage.end() ; l_stage_iter++ )
			{
				l_stage_iter->DumpToDisk( &file );
			}

			return true;
		}
	}
	else if( pFile->m_hFile )
	{
		//  Ϸ 
		CString strStageCount;
		strStageCount.Format( L"%d", m_listOfStage.size() );
		pFile->WriteString( strStageCount );

		// Ϸ 
		// m_listOfStage  Ѵ.
		list<CStage> ::iterator l_stage_iter;
		for( l_stage_iter = m_listOfStage.begin() ; l_stage_iter != m_listOfStage.end() ; l_stage_iter++ )
		{
			l_stage_iter->DumpToDisk( pFile );
		}

		return true;
	}

	return false;
}


//  ó
bool CSMEPackage::ProcessStage( STAGEOPCODE sopCode, int nStageUID /*= -1*/ )
{
	ASSERT( sopCode >= SOP_NEW && sopCode < _END_STAGEOPCODE_ );

	bool bResult = false;

	//  
	if( sopCode == SOP_NEW )
	{
		ASSERT( nStageUID == -1 );

		// TODO :   Ʒ ˰ غ 
		int nLastUID = 0;

		if( m_listOfStage.size() > 0 )
		{
			CStage stage = m_listOfStage.back();

			if( stage.HasValidStage() )
			{
				nLastUID = stage.m_nStageUID + 1;
			}
		}

		CStage newStage;
		newStage.CreateStage( nLastUID );
		m_listOfStage.push_back( newStage );

		m_currentStage = newStage;

		CString str;
		str.Format( L"%dth Stage added.", nLastUID + 1 );
		AfxMessageBox( str );
	}
	//  
	else if( sopCode == SOP_DELETE )
	{

	}
	//  
	else if( sopCode == SOP_SAVE )
	{

	}

	return bResult;
}

// UID  Stage ã
CStage* CSMEPackage::FindStage( int nStageUID )
{


	return NULL;
}


// б   
const CStage* CSMEPackage::GetCurrentStage()
{ 
	if( m_currentStage.HasValidStage() ) 
		return reinterpret_cast<const CStage*>( &m_currentStage ); 
	
	return NULL;
}


// Ⱑ  
CStage* CSMEPackage::GetCurrentStageWriteable()
{ 
	if( m_currentStage.HasValidStage() ) 
		return reinterpret_cast<CStage*>( &m_currentStage ); 

	return NULL;
}