// added by leese 2006-05-16

#include "StdAfx.h"
#include ".\smepackagemanager.h"
#include "PackageManager.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif 

using namespace PackageManager;



CSMEPackageManager::CSMEPackageManager(void)
: m_pPackage ( NULL )
{
}

CSMEPackageManager::~CSMEPackageManager(void)
{
	if( m_pPackage )
		delete m_pPackage;
}

// Ű 
bool CSMEPackageManager::CreatePackage(void)
{
	if( m_pPackage )
	{
		delete m_pPackage;
		m_pPackage = NULL;
	}

	m_pPackage = new CSMEPackage;

	return true;
}

// Ű ε
bool CSMEPackageManager::LoadPackage(void)
{
	bool bResult = false;
	CString strFilter = L"Map Files (*.smp)|*.smp||";


	CFileDialog dlg( TRUE, L"smp", L"", OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, strFilter );
	if( dlg.DoModal() == IDOK )
	{
		CString strPathName = dlg.GetPathName();

		CStdioFile file( strPathName, CStdioFile::modeRead | CStdioFile::modeNoTruncate );

		CreatePackage();

		bResult = m_pPackage->LoadFromDisk( &file );

		file.Close();
	}

	return bResult;
}

// Ű 
bool CSMEPackageManager::SavePackage(void)
{
	bool bResult = false;

	if( m_pPackage )
	{
		bResult = m_pPackage->DumpToDisk();
	}

	return bResult;
}


// ̸ Ű 
bool CSMEPackageManager::SaveAsPackage(void)
{
	bool bResult = false;

	if( m_pPackage )
	{
		CString strFilter = L"Map Files (*.smp)|*.smp||";
		CFileDialog dlg( FALSE, L"smp", L"", OFN_HIDEREADONLY|OFN_FILEMUSTEXIST , strFilter );

		if( dlg.DoModal() == IDOK )
		{
			//  
			CString strPathName = dlg.GetPathName();

			CStdioFile file( strPathName, CStdioFile::modeCreate | CStdioFile::modeWrite | CStdioFile::modeNoTruncate );

			bResult = m_pPackage->DumpToDisk( &file );

			file.Close();
		}
	}

	return bResult;
}