#include "StdAfx.h"
#include ".\command.h"
#include "SMEDoc.h"

Command::Command(void)
{
}

Command::~Command(void)
{
}

CommandPen::CommandPen(CSMEDoc* doc, const int row, const int column)
{
	m_level = doc->getCurrentLevel();
	m_row = row;
	m_column = column;
	m_cellType = doc->getCellType();
	m_originalCellType = doc->getCurrentStage()->getCell(row, column);
}
CommandPen::~CommandPen(void)
{
}

bool CommandPen::redo(CSMEDoc* doc)
{
	bool result = true;

	if (m_cellType != m_originalCellType)
		doc->changeCell(m_level, m_row, m_column, m_cellType);
	return result;
}
void CommandPen::undo(CSMEDoc* doc)
{
	doc->moveStage(m_level);
	doc->changeCell(m_level, m_row, m_column, m_originalCellType);
}

CommandAddStage::CommandAddStage(CSMEDoc* doc, const int row, const int column)
{
	m_level = doc->getCurrentLevel();
	m_row = row;
	m_column = column;
}
CommandAddStage::~CommandAddStage(void)
{
}

bool CommandAddStage::redo(CSMEDoc* doc)
{
	bool result = true;
	doc->addStageAt(m_row, m_column, m_level);
	return result;
}

void CommandAddStage::undo(CSMEDoc* doc)
{
	doc->deleteStageAt(m_level+1);
	doc->moveStage(m_level);
}