#pragma once
#include "DataType.h"
class CSMEDoc;
class Command
{
public:
	Command(void);
	virtual ~Command(void);

	virtual bool redo(CSMEDoc* doc) = 0;
	virtual void undo(CSMEDoc* doc) = 0;
};

class CommandPen : public Command
{
public:
	CommandPen(CSMEDoc* doc, const int row, const int column);
	virtual ~CommandPen(void);

	virtual bool redo(CSMEDoc* doc);
	virtual void undo(CSMEDoc* doc);
private:
	int m_level;
	int m_row;
	int m_column;
	CellType m_cellType;
	CellType m_originalCellType;
};

class CommandAddStage : public Command
{
public:
	CommandAddStage(CSMEDoc* doc, const int row = 10, const int column = 10);
	virtual ~CommandAddStage(void);

	virtual bool redo(CSMEDoc* doc);
	virtual void undo(CSMEDoc* doc);
private:
	int m_level;
	int m_row;
	int m_column;
};