// $Id: SMEDoc.cpp,v 1.50 2006/06/20 11:48:56 gyehongpark Exp $

// SMEDoc.cpp : CSMEDoc Ŭ 
//

#include "stdafx.h"
#include "Command.h"

#include "SME.h"
#include "SMEDoc.h"
#include ".\smedoc.h"
#include <string>

#include "DlgForStageSize.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

using namespace std;

// CSMEDoc

IMPLEMENT_DYNCREATE(CSMEDoc, CDocument)

BEGIN_MESSAGE_MAP(CSMEDoc, CDocument)
	ON_COMMAND(ID_EDIT_CUT, OnEditCut)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_COMMAND(ID_EDIT_DELETE, OnEditDelete)
	ON_COMMAND(ID_STAGE_RESIZE, OnStageResize)
	ON_COMMAND(ID_ADD_DEFAULT_STAGE, OnAddDefaultStage)
	ON_COMMAND(ID_ADD_STAGE, OnAddStage)
	ON_COMMAND(ID_STAGE_FIRST, OnStageFirst)
	ON_COMMAND(ID_STAGE_LAST, OnStageLast)
	ON_COMMAND(ID_STAGE_NEXT, OnStageNext)
	ON_COMMAND(ID_STAGE_PREV, OnStagePrev)
	ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
	ON_COMMAND(ID_EDIT_REDO, OnEditRedo)
END_MESSAGE_MAP()


// CSMEDoc /Ҹ

CSMEDoc::CSMEDoc() : m_package(0), m_currentLevel(0), m_modifiedCount(0)
{
	//  õ 
	m_toolType = TOOL_SELECT;
	m_cellType = FG;
}

CSMEDoc::~CSMEDoc()
{
	removeAll(m_undo);
	removeAll(m_redo);
}

BOOL CSMEDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: ⿡ ٽ ʱȭ ڵ带 ߰մϴ.
	// SDI    ٽ մϴ.
	delete m_package;
	m_modifiedCount = 0;

	m_package = new Package();
	setToolType(TOOL_PEN);
	setCellType(WALL);

	m_currentLevel = m_package->addStageAt();
	m_modifiedCount++;
	this->SetModifiedFlag(IsModifiedCheck());

	UpdateAllViews(NULL);
	return TRUE;
}

BOOL CSMEDoc::OnOpenDocument(LPCTSTR lpszPathName)
{
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;
	// TODO:  Add your specialized creation code here
	setToolType(TOOL_PEN);
	setCellType(WALL);
	return TRUE;
}

// CSMEDoc serialization

void CSMEDoc::savePackage(CArchive& ar)
{
	int stageCount = m_package->getStageCount();
	CString tempString = "";
	tempString.Format("%d\r\n", stageCount);

	ar.WriteString(tempString);
	CString strPackage = "";
	for (int i = 0 ; i < stageCount ; ++i)
	{
		strPackage += m_package->getStageInStringAt(i + 1);
	}
	ar.WriteString(strPackage);
	m_modifiedCount = 0;
}

void CSMEDoc::loadPackage(CArchive& ar)
{
	CString temp;
	do
	{
		ar.ReadString(temp);
	}
	while (temp[0] == ';' || temp.Trim() == "");

	int stageCount;	
	stageCount = atoi((LPCTSTR) temp);

	int cnt;
	int column;
	int row;
	string stageString;

	for (cnt = 0 ; cnt < stageCount ; ++cnt)
	{
		do
		{
			ar.ReadString(temp);
		}
		while (temp[0] == ';' || temp.Trim() == "");

		sscanf((LPCTSTR) temp, "%d%d", &row, &column);
		stageString = "";
		stageString = temp + "\r\n" ;

		for (int r = 0 ; r < row; ++r)
		{
			ar.ReadString(temp);
			stageString += temp + "\r\n";
		}

		m_package->addStageAt(stageString, LAST);
	}
}

void CSMEDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: ⿡  ڵ带 ߰մϴ.
		savePackage(ar);
	}
	else
	{
		delete m_package;
		m_package = new Package;
		loadPackage(ar);
		m_currentLevel = 1;
	}
}


// CSMEDoc 

#ifdef _DEBUG
void CSMEDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CSMEDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG


// CSMEDoc 


void CSMEDoc::OnCloseDocument()
{
	// TODO: Add your specialized code here and/or call the base class
	if (IsOpenedPackage())
	{
		delete m_package;
	}
	CDocument::OnCloseDocument();
}

void CSMEDoc::setToolType(ToolType type)
{
	m_toolType = type;
}

ToolType CSMEDoc::getToolType(void)
{
	return m_toolType;
}

bool CSMEDoc::changeCell(int row, int column)
{
	return changeCell(m_currentLevel, row, column, m_cellType);
}

bool CSMEDoc::changeCell(int level, int row, int column, CellType cellType)
{
	return m_package->changeCell(level, row, column, cellType);
}

void CSMEDoc::setCellType(CellType type)
{
	m_cellType = type;
}

CellType CSMEDoc::getCellType(void)
{
	return m_cellType;
}

void CSMEDoc::moveStage(StageType type)
{
	if (IsOpenedPackage() && IsExistStage())
	{
		switch (type)
		{
		case FIRSTSTAGE:
			m_currentLevel = 1;
			break;
		case LASTSTAGE:
			m_currentLevel = m_package->getStageCount();
			break;
		case PREVSTAGE:
			m_currentLevel -= 1;
			break;
		case NEXTSTAGE:
			m_currentLevel += 1;
			break;
		}
	}
}

void CSMEDoc::moveStage(const int level)
{
	if (level < 1)
		m_currentLevel = level;
	else if (level > m_package->getStageCount())
		m_currentLevel = m_package->getStageCount();
	else
		m_currentLevel = level;
}

int CSMEDoc::getCurrentLevel(void)
{
	return m_currentLevel;
}

int CSMEDoc::getStageCount(void)
{
	return m_package->getStageCount();
}

void CSMEDoc::OnEditCut()
{
	m_package->cutStageAt(getCurrentLevel());
	m_modifiedCount++;
	this->SetModifiedFlag(IsModifiedCheck());
	UpdateAllViews(NULL);
}

void CSMEDoc::OnEditCopy()
{
	m_package->copyStageAt(getCurrentLevel());
}

void CSMEDoc::OnEditPaste()
{
	int level;
	if (level = m_package->pasteStageAt(getCurrentLevel()))
	{
		m_currentLevel = level;
		m_modifiedCount++;
		this->SetModifiedFlag(IsModifiedCheck());
	}

	UpdateAllViews(NULL);
}

void CSMEDoc::OnEditDelete()
{
	m_package->deleteStageAt(getCurrentLevel());
	UpdateAllViews(NULL);
}

void CSMEDoc::OnStageResize()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	CDlgForStageSize dlg(NULL, getCurrentStage()->getRow(),
		getCurrentStage()->getColumn());
	if (dlg.DoModal() == IDOK)
	{
		m_package->resize(m_currentLevel, dlg.m_row, dlg.m_column);
		UpdateAllViews(NULL);
	}
}

void CSMEDoc::OnAddDefaultStage()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	commandDefaultAddStage();
	UpdateAllViews(NULL);
	return;

	m_currentLevel = m_package->addStageAt(0, 0, m_currentLevel + 1);

	m_modifiedCount++;
	this->SetModifiedFlag(IsModifiedCheck());
	UpdateAllViews(NULL);
}

bool CSMEDoc::commandDefaultAddStage()
{
	CommandAddStage* cmd = new CommandAddStage(this);
	if (false == commandDo(cmd))
	{
		delete cmd;
	}

	return true;
}

void CSMEDoc::addStageAt(const int row, const int column, const int level)
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	m_currentLevel = m_package->addStageAt(row, column, level + 1);
}

void CSMEDoc::deleteStageAt(const int level)
{
	m_package->deleteStageAt(level);
	m_currentLevel = level - 1;
}

void CSMEDoc::OnAddStage()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	CDlgForStageSize dlg;
	if (dlg.DoModal() == IDOK)
	{
		m_currentLevel = m_package->addStageAt(dlg.m_row, dlg.m_column,
										m_currentLevel + 1);

		m_modifiedCount++;
		this->SetModifiedFlag(IsModifiedCheck());
		UpdateAllViews(NULL);
	}
}

void CSMEDoc::OnStageFirst()
{
	moveStage(FIRSTSTAGE);
	UpdateAllViews(NULL);
}

void CSMEDoc::OnStageLast()
{
	moveStage(LASTSTAGE);
	UpdateAllViews(NULL);
}

void CSMEDoc::OnStageNext()
{
	moveStage(NEXTSTAGE);
	UpdateAllViews(NULL);
}

void CSMEDoc::OnStagePrev()
{
	moveStage(PREVSTAGE);
	UpdateAllViews(NULL);
}

bool CSMEDoc::commandPen(const int row, const int column)
{
	if (getCellType() != getCurrentStage()->getCell(row, column))
	{
		CommandPen* cmd = new CommandPen(this, row, column);
		if (false == commandDo(cmd))
		{
			delete cmd;
		}

		return true;
	}
	return false;
}

bool CSMEDoc::commandDo(Command* cmd)
{
	bool result = cmd->redo(this);
	if (true == result)
	{
		m_undo.push(cmd);
		m_modifiedCount++;
		this->SetModifiedFlag(IsModifiedCheck());
		removeAll(m_redo);
	}
	return result;
}

bool CSMEDoc::redo()
{
	Command* cmd = m_redo.top();
	m_redo.pop();

	bool result = cmd->redo(this);
	if (true == result)
	{
		m_undo.push(cmd);
		m_modifiedCount++;
		this->SetModifiedFlag(IsModifiedCheck());
	}

	return result;
}

void CSMEDoc::undo()
{
	Command* cmd = m_undo.top();
	m_undo.pop();

	cmd->undo(this);
	m_modifiedCount--;
	this->SetModifiedFlag(IsModifiedCheck());
	m_redo.push(cmd);

	// UpdateAllView  ȣϴ°?
}

void CSMEDoc::removeAll(std::stack<Command*>& stackDo)
{
	stack<Command*>::size_type i;
	stack<Command*>::size_type endi;

	endi = stackDo.size();
	for (i = 0; i < endi; i++)
	{
		delete stackDo.top();
		stackDo.pop();
	}
}
void CSMEDoc::OnEditUndo()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	undo();
	UpdateAllViews(NULL);
}

void CSMEDoc::OnEditRedo()
{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	redo();
	UpdateAllViews(NULL);
}
