// $Id: SMEDoc.h,v 1.25 2006/06/14 14:10:12 youni73 Exp $

// SMEDoc.h : CSMEDoc Ŭ ̽
//
#pragma once

#include"Package.h"
#include"Stage.h"
#include"DataType.h"
#include <stack>

class Command;
class CSMEDoc : public CDocument
{
protected: // serialization ϴ.
	CSMEDoc();
	DECLARE_DYNCREATE(CSMEDoc);

	// Ư
private:
	int m_currentLevel;
	Package* m_package;
	ToolType m_toolType;	//  õ 
	CellType m_cellType;
	int m_modifiedCount;
	std::stack<Command*> m_undo;
	std::stack<Command*> m_redo;

public:
	BOOL IsModifiedCheck() const
	{
		if (true == this->IsOpenedPackage())
		{
			if (0 != m_modifiedCount)
			{
				return TRUE;
			}
		}
		return FALSE;
	}

	bool IsExistUndo() const
	{
		if (true == this->IsOpenedPackage())
		{
			if (m_undo.size() != 0)
				return true;
		}
		return false;
	}

	bool IsExistRedo() const
	{
		if (true == this->IsOpenedPackage())
		{
			if (m_redo.size() != 0)
				return true;
		}
		return false;
	}

	bool IsOpenedPackage() const
	{
		if (0 != m_package)
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	bool IsExistStage() const
	{
		if (0 != getCurrentStage())
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	Stage* getCurrentStage() const
	{
		if (true == this->IsOpenedPackage())
		{
			if (0 != m_currentLevel)
			{
				return m_package->getStageAt(m_currentLevel);
			}
		}

		return 0;
	}

	void removeAll(std::stack<Command*>& stackDo);
	bool commandDo(Command* cmd);
	bool commandPen(const int row, const int column);
	bool commandDefaultAddStage();
	void addStageAt(const int row, const int column, const int level);
	void deleteStageAt(const int level);
	bool redo();
	void undo();
	// ۾
public:

	// 
public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);

	// 
public:
	virtual ~CSMEDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

	// ޽  Լ ߽ϴ.
protected:
	DECLARE_MESSAGE_MAP()
public:
	void savePackage(CArchive& ar);
	void loadPackage(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual void OnCloseDocument();
	void setToolType(ToolType type);
	ToolType getToolType(void);
	bool changeCell(int row, int column);
	bool changeCell(int level, int row, int column, CellType cellType);

	void setCellType(CellType type);
	CellType getCellType(void);
	void moveStage(StageType type);
	void moveStage(const int level);
	int getCurrentLevel(void);
	int getStageCount(void);

public:
	afx_msg void OnEditCut();
	afx_msg void OnEditCopy();
	afx_msg void OnEditPaste();
	afx_msg void OnEditDelete();
	afx_msg void OnStageResize();
	afx_msg void OnAddDefaultStage();
	afx_msg void OnAddStage();
	afx_msg void OnStageFirst();
	afx_msg void OnStageLast();
	afx_msg void OnStageNext();
	afx_msg void OnStagePrev();
	afx_msg void OnEditUndo();
	afx_msg void OnEditRedo();
};


