// $Id: SMEView.cpp,v 1.18 2006/06/12 17:08:15 gyehongpark Exp $

// SMEView.cpp : CSMEView Ŭ 
//

#include "stdafx.h"
#include "SME.h"

#include "SMEDoc.h"
#include "SMEView.h"
#include ".\smeview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSMEView

IMPLEMENT_DYNCREATE(CSMEView, CView)

BEGIN_MESSAGE_MAP(CSMEView, CView)
	// ǥ μ Դϴ.
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
END_MESSAGE_MAP()

// CSMEView /Ҹ

CSMEView::CSMEView()
{
	// TODO: ⿡  ڵ带 ߰մϴ.
	m_viewX = 3;
	m_viewY = 3;
	m_interval = 2;
}

CSMEView::~CSMEView()
{
}

BOOL CSMEView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: CREATESTRUCT cs Ͽ ⿡
	// Window Ŭ Ǵ Ÿ մϴ.

	return CView::PreCreateWindow(cs);
}

// CSMEView ׸

void CSMEView::OnDraw(CDC* pDC)
{
	CSMEDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: ⿡  Ϳ  ׸ ڵ带 ߰մϴ.
	if (true == pDoc->IsExistStage())
	{
		drawBoard(pDC, m_viewX, m_viewY, m_interval);
		drawMap(pDC, m_viewX, m_viewY);
	}
}

void CSMEView::drawBoard(CDC* pDC, const int x, const int y,
	const int interval)
{
	CSMEDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	const Stage* stage = pDoc->getCurrentStage();
	int row = stage->getRow();
	int column = stage->getColumn();

	//pDC->Rectangle(x - interval, y - interval, x + 24 * column + interval,
	//		y + 24 * row + interval);
	pDC->MoveTo(x - interval, y - interval);
	pDC->LineTo(x - interval, y + 24 * row + interval);
	pDC->LineTo(x + 24 * column + interval, y + 24 * row + interval);
	pDC->LineTo(x + 24 * column + interval, y - interval);
	pDC->LineTo(x - interval, y - interval);
}

void CSMEView::drawMap(CDC* pDC, const int x, const int y)
{
	CSMEDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	const Stage* stage = pDoc->getCurrentStage();
	int row = stage->getRow();
	int column = stage->getColumn();

	CDC mapDC;
	CBitmap mapBitmap;

	mapDC.CreateCompatibleDC(pDC);
	mapBitmap.CreateCompatibleBitmap(pDC, 24 * column, 24 * row);
	CBitmap* oldBitmap = (CBitmap*) mapDC.SelectObject(&mapBitmap);
	for (int r = 0; r < row; r++)
	{
		for (int c = 0; c < column; c++)
		{
			drawCell(&mapDC, r, c, stage->getCell(r, c));
		}
	}

	pDC->BitBlt(x, y, x + 24 * column, y + 24 * row, &mapDC, 0, 0, SRCCOPY);
	mapDC.SelectObject(oldBitmap);
}

void CSMEView::drawCell(CDC* pDC, int row, int column, CellType cell)
{
	CDC memDC;
	memDC.CreateCompatibleDC(pDC);
	CBitmap bitmap;
	CBitmap* oldBitmap;

	UINT bmpID;
	switch (cell)
	{
	case BG:
		bmpID = IDB_BITMAP_BG;
		break;
	case FG:
		bmpID = IDB_BITMAP_FG;
		break;
	case TARGET:
		bmpID = IDB_BITMAP_TARGET;
		break;
	case WALL:
		bmpID = IDB_BITMAP_WALL;
		break;
	case BURDEN:
		bmpID = IDB_BITMAP_BURDEN;
		break;
	case PORTER:
		bmpID = IDB_BITMAP_PORTER;
		break;
	case BURDENTARGET:
		bmpID = IDB_BITMAP_BURDENTARGET;
		break;
	case PORTERTARGET:
		bmpID = IDB_BITMAP_PORTERTARGET;
		break;
	default:
		bmpID = IDB_BITMAP_FG;
		break;
	}
	bitmap.LoadBitmap(bmpID);
	oldBitmap = (CBitmap *) memDC.SelectObject(&bitmap);
	pDC->BitBlt(column * 24, row * 24, 24, 24, &memDC, 0, 0, SRCCOPY);

	memDC.SelectObject(oldBitmap);
}
// CSMEView μ

BOOL CSMEView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ⺻ غ
	return DoPreparePrinting(pInfo);
}

void CSMEView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: μϱ  ߰ ʱȭ ۾ ߰մϴ.
}

void CSMEView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: μ   ۾ ߰մϴ.
}


// CSMEView 

#ifdef _DEBUG
void CSMEView::AssertValid() const
{
	CView::AssertValid();
}

void CSMEView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CSMEDoc* CSMEView::GetDocument() const // ׵   ζ ˴ϴ.
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSMEDoc)));
	return (CSMEDoc *) m_pDocument;
}
#endif //_DEBUG


// CSMEView ޽ ó

void CSMEView::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.
	CSMEDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	switch (pDoc->getToolType())
	{
	case TOOL_PEN:
		{
			int row = (point.y - (m_viewY + m_interval)) / 24;
			int column = (point.x - (m_viewX + m_interval)) / 24;

			if (true == pDoc->commandPen(row, column))
			{
				CRect rect(column * 24, row * 24, column * 24 + 27,
					row * 24 + 27);
				InvalidateRect(rect, false);
			}
		}
		break;
	default:
		break;
	}

	CView::OnLButtonDown(nFlags, point);
}
void CSMEView::OnLButtonUp(UINT nFlags, CPoint point)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.
	CSMEDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	switch (pDoc->getToolType())
	{
	case TOOL_PEN:
		{
			int row = (point.y - (m_viewY + m_interval)) / 24;
			int column = (point.x - (m_viewX + m_interval)) / 24;

			if (true == pDoc->commandPen(row, column))
			{
				CRect rect(column * 24, row * 24, column * 24 + 27,
					row * 24 + 27);
				InvalidateRect(rect, false);
			}
		}
		break;
	default:
		break;
	}
	CView::OnLButtonUp(nFlags, point);
}

void CSMEView::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.
	CSMEDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	if (nFlags & MK_LBUTTON)
	{
		switch (pDoc->getToolType())
		{
		case TOOL_PEN:
			{
				int row = (point.y - (m_viewY + m_interval)) / 24;
				int column = (point.x - (m_viewX + m_interval)) / 24;

				if (true == pDoc->commandPen(row, column))
				{
					CRect rect(column * 24, row * 24, column * 24 + 27,
						row * 24 + 27);
					InvalidateRect(rect, false);
				}
			}

			break;
		default:
			break;
		}
	}
	CView::OnMouseMove(nFlags, point);
}
