// $Id: Stage.cpp,v 1.27 2006/06/12 16:56:15 gyehongpark Exp $

#include "StdAfx.h"
#include ".\stage.h"
#include <sstream>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

using namespace std;

Stage::Stage(std::string str)
{
	if (0 == str.compare("default"))
	{
		m_row = 10;
		m_column = 10;
		m_map = new CellType * [m_row];
		for (int r = 0; r < m_row; r++)
		{
			m_map[r] = new CellType[m_column];
			//memset(m_map[r], FG, sizeof(CellType) * m_column);
			for (int c = 0; c < m_column; c++)
				m_map[r][c] = FG;
		}
	}
	else
	{
		istringstream istr;
		istr.str(str);

		int row;
		int column;
		string tempString;
		do
		{
			istr >> tempString;
		}
		while (tempString[0] == ';');
		row = atoi(tempString.c_str());
		istr >> column;

		m_row = row;
		m_column = column;

		m_map = new CellType * [row];
		char garbage[2];
		char buf[128];
		for (int r = 0; r < row; r++)
		{
			istr.read(garbage, 2);
			m_map[r] = new CellType[column];
			//istr.read(reinterpret_cast<char*>(m_map[r]), column);
			istr.read(buf, column);
			for (int c = 0; c < m_column; c++)
				m_map[r][c] = static_cast<CellType>(buf[c]);
		}
	}
}

Stage::Stage(int row, int column)
{
	m_row = row;
	m_column = column;
	m_map = new CellType * [m_row];
	for (int r = 0; r < m_row; r++)
	{
		m_map[r] = new CellType[m_column];
		//memset(m_map[r], FG, sizeof(CellType) * m_column);
		for (int c = 0; c < m_column; c++)
			m_map[r][c] = FG;
	}
}

Stage::~Stage(void)
{
	for (int r = 0 ; r < m_row; ++r)
		delete[] m_map[r];
	delete[] m_map;
}

CellType Stage::getCell(const int row, const int column) const
{
	if (0 <= row && row < m_row && 0 <= column && column < m_column)
	{
		return m_map[row][column];
	}
	else
	{
		return NO_DATA;
	}
}
void Stage::setCell(const int row, const int column, CellType cellType)
{
	m_map[row][column] = cellType;
}


const CString Stage::getStageInstring() const
{
	CString strStage;
	strStage = ";stage\r\n";
	CString tempString;
	tempString.Format("%d %d\r\n", m_row, m_column);
	strStage += tempString;

	for (int r = 0 ; r < m_row ; r++)
	{
		for (int c = 0 ; c < m_column ; c++)
		{
			strStage += static_cast<char>(m_map[r][c]);
		}
		strStage += "\r\n";
	}

	return strStage;
}

void Stage::resize(const int row, const int column)
{
	CellType** map = new CellType * [row];
	int rowsize = (row > m_row) ? m_row : row;
	int size = (column > m_column) ? m_column : column;
	for (int r = 0; r < rowsize; r++)
	{
		map[r] = new CellType[column];
		//memset(map[r], BG, sizeof(CellType) * column);
		for (int c = 0; c < column; c++)
			map[r][c] = FG;
		memcpy(map[r], m_map[r], sizeof(CellType) * size);
	}

	for (int r = 0; r < m_row; r++)
		delete[] m_map[r];
	delete[] m_map;

	m_map = map;
	m_row = row;
	m_column = column;
}