// $Id: Stage.h,v 1.17 2006/06/12 15:46:02 gyehongpark Exp $

#pragma once
#include <string>
#include"DataType.h"

class Stage
{
private:
	int m_row;
	int m_column;
	CellType** m_map;
public:
	static const int MAX_HEIGHT = 50;
	static const int MAX_WIDTH = 50;
	static const int MIN_WIDTH = 0;
	static const int MIN_HEIGHT = 0;

	Stage(std::string str = "default");
	Stage(int row, int column);


	~Stage(void);
	CellType getCell(const int row, const int column) const;
	void setCell(const int row, const int column, CellType cellType);

	const CString getStageInstring() const;

	inline int getRow() const
	{
		return m_row;
	}
	inline int getColumn() const
	{
		return m_column;
	}
	void resize(const int row, const int column);
};
