#include "StdAfx.h"
#include ".\package.h"

using namespace std;

Package::Package(void)
	: m_totalLevel(0)
	{
	TRACE("create Package\n");
	}

Package::~Package(void)
	{
	list<Stage*>::iterator itr;
	for (itr = m_stageList.begin(); itr != m_stageList.end(); itr++)
		{
		delete * itr;
		}
	m_stageList.clear();
	TRACE("delete Package\n");
	}

const int Package::addStage(const int row, const int column, const int level)
	{
	int insertLevel = correctLevel(level, true);
	Stage *stage = new Stage(row, column);
	list<Stage*>::iterator itr = m_stageList.begin();
	int tmpLevel = 1;
	while (tmpLevel < insertLevel)
		{
		itr++;
		tmpLevel++;
		}
	m_stageList.insert(itr, stage);
	m_totalLevel++;

	return insertLevel;
	}

const int Package::addStage(Stage *stage, const int level)
	{
	int insertLevel = correctLevel(level, true);
	list<Stage*>::iterator itr = m_stageList.begin();
	int tmpLevel = 1;
	while (tmpLevel < insertLevel)
		{
		itr++;
		tmpLevel++;
		}
	m_stageList.insert(itr, stage);
	m_totalLevel++;

	return insertLevel;
	}

const int Package::addStage(const char *stageString, const int level)
    {
	Stage *stage = new Stage(0, 0);
	stage->setStageString(stageString);
	return addStage(stage, level);
    }

const Stage * Package::getStage(const int level)
	{
	Stage *result = 0;
	int getLevel = correctLevel(level);
	list<Stage*>::iterator itr = m_stageList.begin();
	int tmpLevel = 1;
	while (tmpLevel < getLevel)
		{
		itr++;
		tmpLevel++;
		}
	result = *itr;
	return result;
	}

const int Package::correctLevel(const int level, const bool addFlag)
	{
	int resultLevel;

	if (ENDLEVEL == level || level > m_totalLevel)
		{
		resultLevel = m_totalLevel + addFlag;
		}
	else if (BEGINLEVEL == level || 0 > level)
		{
		resultLevel = 1;
		}
	else
		{
		resultLevel = level;
		}

	return resultLevel;
	}

const int Package::deleteStage(const int level)
	{
	const int resultLevel = correctLevel(level);

	if (1 > resultLevel)
		{
		return 0;
		}
	list<Stage*>::iterator itr = m_stageList.begin();
	int tmpLevel = 1;
	while (tmpLevel < resultLevel)
		{
		itr++;
		tmpLevel++;
		}
	delete * itr;
	m_stageList.erase(itr);
	m_totalLevel--;

	return resultLevel;
	}

void Package::setCell(const int level, const int row, const int column, const int cell)
	{
	Stage *stage = const_cast<Stage *>(getStage(level));
	stage->setCell(cell, row, column);
	}

void Package::resize(const int level, const int row, const int column)
	{
	Stage *stage = const_cast<Stage *>(getStage(level));
	stage->resize(row, column);
	}
