#pragma once
#include <list>
#include "Stage.h"

class Package
	{
public:
	Package(void);
	~Package(void);

	enum
		{
		ENDLEVEL = -1
		, BEGINLEVEL = 0
		};

	const int addStage(const int row = 10, const int column = 10, const int level = ENDLEVEL);
	const int addStage(Stage *stage, const int level = ENDLEVEL);
    const int addStage(const char *stageString, const int level = ENDLEVEL);
	const int deleteStage(const int level);
	const int getTotalLevel() const
		{
		return m_totalLevel;
		}
	const Stage *getStage(const int level);
	const int correctLevel(const int level, const bool addFlag = false);
	void setCell(const int level, const int row, const int column, const int cell);
	void resize(const int level, const int row, const int column);
protected:
	int m_totalLevel;
	std::list<Stage*> m_stageList;
	};
