// SMEDoc.cpp : CSMEDoc Ŭ 
//

#include "stdafx.h"
#include "SME.h"

#include "SMEDoc.h"
#include ".\smedoc.h"

#include "ResizeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif
// CSMEDoc

IMPLEMENT_DYNCREATE(CSMEDoc, CDocument)

BEGIN_MESSAGE_MAP(CSMEDoc, CDocument)
	ON_COMMAND_RANGE(ID_STAGE_BEGIN, ID_STAGE_END, OnStageMove)
	ON_COMMAND(ID_STAGE_NEW, OnStageNew)
	ON_COMMAND(ID_STAGE_NEWSIZE, OnStageNewsize)
	ON_COMMAND(ID_STAGE_RESIZE, OnStageResize)
	ON_COMMAND(ID_STAGE_CUT, OnStageCut)
	ON_COMMAND(ID_STAGE_COPY, OnStageCopy)
	ON_COMMAND(ID_STAGE_PASTE, OnStagePaste)
	ON_COMMAND(ID_STAGE_DELETE, OnStageDelete)
	ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
	ON_COMMAND(ID_FILE_CLOSE, OnFileClose)
END_MESSAGE_MAP()

// CSMEDoc /Ҹ

CSMEDoc::CSMEDoc()
	: m_package(0)
	, m_currentLevel(0)
	, m_newStageRow(10)
	, m_newStageColumn(10)
	, m_selectTool(ID_TOOL_PEN)
	{
	// TODO: ⿡ ȸ  ڵ带 ߰մϴ.
	TRACE("create CSMEDoc\n");
	}

CSMEDoc::~CSMEDoc()
	{
	delete m_package;
	TRACE("delete CSMEDoc\n");
	}

BOOL CSMEDoc::OnNewDocument()
	{
	if (!CDocument::OnNewDocument())
		{
		return FALSE;
		}

	// TODO: ⿡ ٽ ʱȭ ڵ带 ߰մϴ.
	// SDI    ٽ մϴ.
	m_package = new Package;
	addStage();

	setModified(RESET);
	setModified(PLUS);
	this->UpdateAllViews(NULL);
	return TRUE;
	}


// CSMEDoc serialization

void CSMEDoc::Serialize(CArchive &ar)
	{
	if (ar.IsStoring())
		{
		// TODO: ⿡  ڵ带 ߰մϴ.
		savePackage(ar);
		}
	else
		{
		// TODO: ⿡ ε ڵ带 ߰մϴ.
        openPackage(ar);        
		}
	}

void CSMEDoc::openPackage(CArchive &ar)
    {
    openPackage_1(ar);
    return;

	CString tempString;
	CString tokenString;
	do
		{
		ar.ReadString(tempString);
		} while (tempString[0] == ';');
	// Map Size

	int totalLevel = atoi(LPCSTR(tempString));

	if (totalLevel > 0)
		{
		int row;
		int column;

        m_package = new Package;

        for (int i = 1; i <= totalLevel; i++)
			{
			int curPos = 0;

			do
				{
				ar.ReadString(tempString);
				}
			while (tempString[0] == ';');

			sscanf((LPCTSTR) tempString, "%d%d", &row, &column);


			Stage *stage = new Stage(row, column);

			for (int y = 0; y < row; y++)
				{
				ar.ReadString(tempString);
				for (int x = 0; x < column; x++)
					{
					stage->setCell(y, x, tempString.GetAt(x));
					}
				}
			m_package->addStage(stage);
			}
		m_currentLevel = 1;
		}
    }

void CSMEDoc::openPackage_1(CArchive &ar)
    {
	CString strTempString;
	do
		{
		ar.ReadString(strTempString);
		} while (strTempString[0] == ';');

		int totalLevel = atoi(strTempString.GetBuffer(0));

	if (totalLevel > 0)
		{
        m_package = new Package;

        int row;

        for (int i = 1; i <= totalLevel; i++)
			{
			do
				{
				ar.ReadString(strTempString);
				} while (strTempString[0] == ';');
            CString strStageString = strTempString + "\n";
			sscanf((LPCTSTR)strTempString, "%d", &row);

			for (int y = 0; y < row; y++)
				{
				ar.ReadString(strTempString);
                strStageString += strTempString + "\n";
				}
			m_package->addStage((LPCSTR)strStageString);
			}
		m_currentLevel = 1;
		}

    }

void CSMEDoc::savePackage(CArchive &ar)
    {
	savePackage_1(ar);
	return;

	CString tempString;
	tempString.Format("%d", m_package->getTotalLevel());
	ar.WriteString(tempString);
	ar << '\n';

	for (int i = 1; i <= m_package->getTotalLevel(); i++)
		{
		const Stage *stage = m_package->getStage(i);

		tempString.Format("%d %d", stage->getRow(), stage->getColumn());
		ar.WriteString(tempString);
		ar << '\n';

		for (int row = 0; row < stage->getRow(); row++)
			{
			for (int col = 0; col < stage->getColumn(); col++)
				{
				ar << stage->getCell(row, col);
				}
			ar << '\n';
			}
		}
    }

void CSMEDoc::savePackage_1(CArchive &ar)
    {
	CString tempString;
	tempString.Format("%d", m_package->getTotalLevel());
	ar.WriteString(tempString);
	ar << '\n';

	for (int i = 1; i <= m_package->getTotalLevel(); i++)
		{
		const Stage *stage = m_package->getStage(i);
		char *stageString = new char [stage->getStageStringSize()+1];
		stage->getStageString(stageString);
		ar.WriteString(stageString);
		delete stageString;
		}
	}

// CSMEDoc 

#ifdef _DEBUG
void CSMEDoc::AssertValid() const
	{
	CDocument::AssertValid();
	}

void CSMEDoc::Dump(CDumpContext &dc) const
	{
	CDocument::Dump(dc);
	}
#endif //_DEBUG


// CSMEDoc 

void CSMEDoc::addStage(const int row, const int column, const int level)
	{
	m_currentLevel = m_package->addStage(row, column, level);
	}

void CSMEDoc::OnStageMove(UINT uID)
	{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	switch (uID)
		{
		case ID_STAGE_BEGIN:
			m_currentLevel = 1;
			break;
		case ID_STAGE_PRE:
			m_currentLevel--;
			break;
		case ID_STAGE_NEXT:
			m_currentLevel++;
			break;
		case ID_STAGE_END:
			m_currentLevel = -1;
			break;
		default:
			m_currentLevel = 1;
			break;
		}
	m_currentLevel = m_package->correctLevel(m_currentLevel);
	this->UpdateAllViews(NULL);
	}

void CSMEDoc::OnStageNew()
	{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	addStage();
	setModified(PLUS);
	this->UpdateAllViews(NULL);
	}

void CSMEDoc::OnStageNewsize()
	{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	CResizeDlg dlg(NULL, m_newStageRow, m_newStageColumn);
	if (IDOK == dlg.DoModal())
		{
		m_newStageRow = dlg.m_iRow;
		m_newStageColumn = dlg.m_iColumn;

		addStage(m_newStageRow, m_newStageColumn, m_currentLevel + 1);
		setModified(PLUS);
		this->UpdateAllViews(NULL);
		}
	}

void CSMEDoc::OnStageResize()
	{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	const Stage *stage = getCurrentStage();
	CResizeDlg dlg(NULL, stage->getRow(), stage->getColumn());
	if (IDOK == dlg.DoModal())
		{
		m_package->resize(m_currentLevel, dlg.m_iRow, dlg.m_iColumn);
		setModified(PLUS);
		this->UpdateAllViews(NULL);
		}
	}

void CSMEDoc::selectStartPos(const int row, const int column)
	{
	m_penPos.first = row;
	m_penPos.second = column;
	}

void CSMEDoc::drawCellwithTool(int toolID, char cell, std::vector<std::pair<int, int> > &data)
	{
	if (ID_TOOL_PEN == toolID)
		{
		drawPen(cell, data[0].first, data[0].second);
		}
	setModified(PLUS);
	}

void CSMEDoc::drawPen(const int cell, const int row, const int column)
	{
	//this->getCurrentStage()->setCell(cell, row, column);
	m_package->setCell(m_currentLevel, cell, row, column);
	}

void CSMEDoc::OnStageCut()
	{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	OnStageCopy();
	OnStageDelete();
	}

void CSMEDoc::OnStageCopy()
	{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	const Stage *stage = this->getCurrentStage();
	char *stageString = new char [stage->getStageStringSize()+1];
	stage->getStageString(stageString);
	HGLOBAL hmem = GlobalAlloc(GHND, strlen(stageString) + 1);
	char *ptr = (char *) GlobalLock(hmem);
	strcpy(ptr, stageString);
	delete [] stageString;
	GlobalUnlock(hmem);
	if (OpenClipboard(AfxGetMainWnd()->GetSafeHwnd()))
		{
		EmptyClipboard();
		SetClipboardData(CF_TEXT, hmem);
		CloseClipboard();
		}
	}

void CSMEDoc::OnStagePaste()
	{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	if (IsClipboardFormatAvailable(CF_TEXT))
		{
		::OpenClipboard(AfxGetMainWnd()->GetSafeHwnd());
		HGLOBAL hmem = ::GetClipboardData(CF_TEXT);
		char *ptr = (char *) ::GlobalLock(hmem);
		char *stageString = new char [strlen(ptr) + 1];
		strcpy(stageString, ptr);
		::GlobalUnlock(hmem);
		::CloseClipboard();
		if (0 == strncmp(stageString, ";stage\n", strlen(";stage\n")))
			{
			Stage *stage = new Stage(1, 1);
			stage->setStageString(stageString);
			m_currentLevel = m_package->addStage(stage, m_currentLevel + 1);

			setModified(PLUS);
			this->UpdateAllViews(NULL);
			}
		}
	}

void CSMEDoc::OnStageDelete()
	{
	// TODO: ⿡  ó ڵ带 ߰մϴ.
	m_currentLevel = m_package->correctLevel(m_package->deleteStage(m_currentLevel));
	setModified(PLUS);
	this->UpdateAllViews(NULL);
	}

void CSMEDoc::OnEditUndo()
	{
	// TODO: ⿡  ó ڵ带 ߰մϴ.

	setModified(MINUS);
	this->UpdateAllViews(NULL);
	}

void CSMEDoc::setModifiedCount(const int op)
	{
	switch (op)
		{
		case MINUS :
			m_modifiedCount--;
			break;
		case RESET :
			m_modifiedCount = 0;
			break;
		case PLUS :
		default:
			m_modifiedCount++;
			break;
		}
	}

void CSMEDoc::setModified(const int op)
	{
	setModifiedCount(op);
	SetModifiedFlag(getModifiedCount());
	}

void CSMEDoc::DeleteContents()
	{
		// TODO: Add your specialized code here and/or call the base class
	delete m_package;
	m_package = 0;

	setModified(RESET);
	CDocument::DeleteContents();
	}

void CSMEDoc::OnFileClose()
	{
	// TODO: Add your command handler code here
	CDocument::SaveModified();
	DeleteContents();
	this->UpdateAllViews(NULL);
	}
