// SMEView.cpp : CSMEView Ŭ 
//

#include "stdafx.h"
#include "SME.h"

#include "SMEDoc.h"
#include "SMEView.h"
#include ".\smeview.h"
#include ".\MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#include <vector>
#include <utility>

using namespace std;

// CSMEView

IMPLEMENT_DYNCREATE(CSMEView, CView)

BEGIN_MESSAGE_MAP(CSMEView, CView)
	// ǥ μ Դϴ.
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
END_MESSAGE_MAP()

// CSMEView /Ҹ

CSMEView::CSMEView()
	{
	// TODO: ⿡  ڵ带 ߰մϴ.
	m_preRow = -1;
	m_preColumn = -1;
	}

CSMEView::~CSMEView()
	{
	}

BOOL CSMEView::PreCreateWindow(CREATESTRUCT &cs)
	{
	// TODO: CREATESTRUCT cs Ͽ ⿡
	// Window Ŭ Ǵ Ÿ մϴ.

	return CView::PreCreateWindow(cs);
	}

// CSMEView ׸
struct STYLES
	{
	int nStyle;
	char szStyleName[16];
	};

void CSMEView::OnDraw(CDC *pDC)
	{
	CSMEDoc *pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		{
		return;
		}

	// TODO: ⿡  Ϳ  ׸ ڵ带 ߰մϴ.
	if (true == pDoc->IsExistStage())
		{
		//int currentLevel = pDoc->getCurrentLevel();
		const Stage *stage = pDoc->getCurrentStage();
		int row = stage->getRow();
		int column = stage->getColumn();

		CDC mapDC;
		CBitmap mapBitmap;

		mapDC.CreateCompatibleDC(pDC);
		mapBitmap.CreateCompatibleBitmap(pDC, 24 * column, 24 * row);
		CBitmap *oldBitmap = (CBitmap *) mapDC.SelectObject(&mapBitmap);
		for (int y = 0; y < row; y++)
			{
			for (int x = 0; x < column; x++)
				{
				drawCell(&mapDC, y, x, stage->getCell(y, x));
				}
			}

		pDC->BitBlt(0, 0, 24 * column, 24 * row, &mapDC, 0, 0, SRCCOPY);
		mapDC.SelectObject(oldBitmap);
		}
	else
		{
		}
	}

void CSMEView::drawCell(CDC *pDC, int row, int column, char cell)
	{
	CDC memDC;
	memDC.CreateCompatibleDC(pDC);
	CBitmap bitmap;
	CBitmap *oldBitmap;

	UINT bmpID;
	switch (cell)
		{
		case Stage::BG:
			bmpID = IDB_BITMAP_BG;
			break;
		case Stage::FG:
			bmpID = IDB_BITMAP_FG;
			break;
		case Stage::TARGET:
			bmpID = IDB_BITMAP_TARGET;
			break;
		case Stage::WALL:
			bmpID = IDB_BITMAP_WALL;
			break;
		case Stage::BURDEN:
			bmpID = IDB_BITMAP_BURDEN;
			break;
		case Stage::PORTER:
			bmpID = IDB_BITMAP_PORTER;
			break;
		case Stage::BURDENTARGET:
			bmpID = IDB_BITMAP_BURDENTARGET;
			break;
		case Stage::PORTERTARGET:
			bmpID = IDB_BITMAP_PORTERTARGET;
			break;
		default:
			bmpID = IDB_BITMAP_FG;
			break;
		}
	bitmap.LoadBitmap(bmpID);
	oldBitmap = (CBitmap *) memDC.SelectObject(&bitmap);
	pDC->BitBlt(column * 24, row * 24, 24, 24, &memDC, 0, 0, SRCCOPY);

	memDC.SelectObject(oldBitmap);
	}

// CSMEView μ

BOOL CSMEView::OnPreparePrinting(CPrintInfo *pInfo)
	{
	// ⺻ غ
	return DoPreparePrinting(pInfo);
	}

void CSMEView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
	{
	// TODO: μϱ  ߰ ʱȭ ۾ ߰մϴ.
	}

void CSMEView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
	{
	// TODO: μ   ۾ ߰մϴ.
	}

// CSMEView 

#ifdef _DEBUG
void CSMEView::AssertValid() const
	{
	CView::AssertValid();
	}

void CSMEView::Dump(CDumpContext &dc) const
	{
	CView::Dump(dc);
	}

CSMEDoc * CSMEView::GetDocument() const // ׵   ζ ˴ϴ.
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSMEDoc)));
	return (CSMEDoc *) m_pDocument;
	}
#endif //_DEBUG

// CSMEView ޽ ó
void CSMEView::OnLButtonDown(UINT nFlags, CPoint point)
	{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.
	CSMEDoc *pDoc = GetDocument();

	if (true == pDoc->IsExistStage())
		{
		if (ID_TOOL_PEN == static_cast<CMainFrame*>(this->GetParentFrame())->getSelectedToolID())
			{
			vector<pair<int, int> > data(1);
			data[0].first = point.y / 24;
			data[0].second = point.x / 24;
			pDoc->drawCellwithTool(ID_TOOL_PEN, static_cast<CMainFrame*>(this->GetParentFrame())->getSelectedCell(), data);

			invalidateRectCellArea(data[0].first, data[0].second = point.x / 24);
			}
		}
	CView::OnLButtonDown(nFlags, point);
	}

void CSMEView::OnLButtonUp(UINT nFlags, CPoint point)
	{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.
	CSMEDoc *pDoc = GetDocument();
	if (true == pDoc->IsExistStage())
		{
		if (ID_TOOL_PEN == static_cast<CMainFrame*>(this->GetParentFrame())->getSelectedToolID())
			{
			vector<pair<int, int> > data(1);
			data[0].first = point.y / 24;
			data[0].second = point.x / 24;
			pDoc->drawCellwithTool(ID_TOOL_PEN, static_cast<CMainFrame*>(this->GetParentFrame())->getSelectedCell(), data);

			invalidateRectCellArea(data[0].first, data[0].second = point.x / 24);
			}
		}
	CView::OnLButtonUp(nFlags, point);
	}

void CSMEView::OnMouseMove(UINT nFlags, CPoint point)
	{
	// TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.
	CSMEDoc *pDoc = GetDocument();
	if (true == pDoc->IsExistStage())
		{
		switch (static_cast<CMainFrame*>(this->GetParentFrame())->getSelectedToolID())
			{
			case ID_TOOL_PEN :
				if (nFlags & MK_LBUTTON)
					{
					vector<pair<int, int> > data(1);
					data[0].first = point.y / 24;
					data[0].second = point.x / 24;
					pDoc->drawCellwithTool(ID_TOOL_PEN, static_cast<CMainFrame*>(this->GetParentFrame())->getSelectedCell(), data);

					invalidateRectCellArea(data[0].first, data[0].second = point.x / 24);
					}
				else
					{
					int row = point.y / 24;
					int column = point.x / 24;
					if (m_preRow != row || m_preColumn != column)
						{
						invalidateRectCellArea(m_preRow, m_preColumn);
						drawSelectSign(row, column);
						}

					m_preRow = row;
					m_preColumn = column;
					}
				break;
			case ID_TOOL_SELECT:
				if (nFlags & MK_LBUTTON)
					{
					}
				else
					{
					int row = point.y / 24;
					int column = point.x / 24;
					if (m_preRow != row || m_preColumn != column)
						{
						invalidateRectCellArea(m_preRow, m_preColumn);
						drawSelectSign(row, column);
						}

					m_preRow = row;
					m_preColumn = column;
					}
				break;
			default:
				if (nFlags & MK_LBUTTON)
					{
					}
				else
					{
					int row = point.y / 24;
					int column = point.x / 24;
					if (m_preRow != row || m_preColumn != column)
						{
						invalidateRectCellArea(m_preRow, m_preColumn);
						drawSelectSign(row, column);
						}

					m_preRow = row;
					m_preColumn = column;
					}
				break;
			}
		}
	CView::OnMouseMove(nFlags, point);
	}

void CSMEView::invalidateRectCellArea(const int row, const int column)
	{
	if (0 <= row && 0 <= column)
		{
		tagRECT rt;
		rt.left = column * 24;
		rt.bottom = row * 24;
		rt.right = rt.left + 24;
		rt.top = rt.bottom + 24;

		InvalidateRect(&rt, FALSE);
		}
	}

void CSMEView::drawSelectSign(const int row, const int column)
	{
	const int stageRow = GetDocument()->getCurrentStage()->getRow();
	const int stageColumn = GetDocument()->getCurrentStage()->getColumn();
	if (row >= 0 && column >= 0 && row < stageRow && column < stageColumn)
		{
		CClientDC dc(this);

		CPen pen(PS_DOT, 1, RGB(0, 0, 0));

		dc.SelectStockObject(NULL_BRUSH);
		CPen *oldPen = dc.SelectObject(&pen);

		dc.Rectangle(column * 24, row * 24, column * 24 + 24, row * 24 + 24);
		dc.SelectObject(oldPen);
		}
	}