#include "StdAfx.h"
#include ".\stage.h"

Stage::Stage(const int row, const int column)
	: m_row(0)
	, m_column(0)
	, m_map(0)
	{
	TRACE("create Stage %d, %d\n", row, column);
	resize(row, column);
	}

Stage::~Stage(void)
	{
	for (int y = 0; y < m_row; y++)
		{
		delete[] m_map[y];
		}
	delete[] m_map;
	TRACE("delete Stage\n");
	}

const bool Stage::resize(const int row, const int column)
	{
	char **tempMap = 0;
	int tempRow = 0;
	int tempColumn = 0;

	if (0 != m_map)
		{
		tempMap = m_map;
		tempRow = m_row;
		tempColumn = m_column;
		}

	m_row = row;
	m_column = column;

	if (0 < row && 0 < column)
		{
		m_map = new char * [m_row];
		for (int i = 0; i < m_row; i++)
			{
			m_map[i] = new char [m_column];
			}
		for (int i = 0; i < m_row; i++)
			{
			for (int j = 0; j < m_column; j++)
				{
				m_map[i][j] = BG;
				}
			}
		}

	if (0 != tempMap)
		{
		if (0 != m_map)
			{
			int endRow = (tempRow > m_row) ? m_row : tempRow;
			int endColumn = (tempColumn > m_column) ? m_column : tempColumn;
			for (int i = 0; i < endRow; i++)
				{
				for (int j = 0; j < endColumn; j++)
					{
					m_map[i][j] = tempMap[i][j];
					}
				}
			}

		for (int i = 0; i < tempRow; i++)
			{
			delete[] tempMap[i];
			}
		delete[] tempMap;
		}

	return true;
	}

const char Stage::getCell(const int row, const int column) const
	{
	if (0 <= row && row < m_row && 0 <= column && column < m_column)
		{
		return m_map[row][column];
		}
	else
		{
		return -1;
		}
	}

void Stage::setCell(const char cell, const int row, const int column)
	{
	if (0 <= row && row < m_row && 0 <= column && column < m_column)
		{
		m_map[row][column] = cell;
		}
	}

const int Stage::getStageStringSize() const
	{
	char szBuf[32];
	sprintf(szBuf, ";stage\n%d %d\n", m_row, m_column);
	return (int)(strlen(szBuf) + m_row * (m_column + 1));
	}

char *Stage::getStageString(char *str) const
	{
	char szBuf[256];
	char ch[2] = "";

	sprintf(szBuf, ";stage\n%d %d\n", m_row, m_column);
	strcpy(str, szBuf);

	for (int y = 0; y < m_row; y++)
		{
		for (int x = 0; x < m_column; x++)
			{
			ch[0] = getCell(y, x);
			strcat(str, ch);
			}
		strcat(str, "\n");
		}
	return str;
	}

void Stage::setStageString(const char *str)
	{
	char *stageString = new char [strlen(str)+1];
	strcpy(stageString, str);
	delete [] stageString;

	char *p;
	int row;
	int column;
	p = strtok(stageString, "\n");
	while (p[0] != ';')
		{
		p = strtok(NULL, "\n");
		}
	p = strtok(NULL, "\n");
	sscanf(p, "%d%d", &row, &column);
	resize(row, column);

	for (int y = 0; y < row; y++)
		{
		p = strtok(NULL, "\n");
		for (int x = 0; x < column; x++)
			{
			setCell(p[x], y, x);
			}
		}
	}