#pragma once

class Stage
	{
public:
	enum
		{
		FG = ' '
		, TARGET = 'T'
		, WALL = '#'
		, BURDEN = 'O'
		, BURDENTARGET = 'b'
		, PORTER = '@'
		, PORTERTARGET = 't'
		, BG = '.'
		};

	static const int c_MAX_LOW = 255;
	static const int c_MAX_COLUMN = 255;

	Stage(const int row = 10, const int column = 10);
	~Stage(void);
	const int getRow() const
		{
		return m_row;
		}
	const int getColumn() const
		{
		return m_column;
		}
	const char getCell(const int row, const int column) const;
	void setCell(const char cell, const int row, const int column);
	const bool resize(const int row, const int column);
	char *getStageString(char *str) const;
	const int getStageStringSize() const;
	void setStageString(const char *str);
protected:
	int m_row;
	int m_column;
	char **m_map;
	};